require 'httparty'
module OffTheGridTrucks
  class Request
    BASE_URL = 'https://api.infrastruckture.com'.freeze
    # This is a public token.
    BEARER_TOKEN = 'Bearer eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpc3MiOiJJbmZyYXN0cnVja3R1cmUiLCJpYXQiOjE1MzkwMzQ0ODQsImV4cCI6MTU0MTYyNjQ4NCwiYXVkIjoiaW5mcmFzdHJ1Y2t0dXJlLmNvbSIsInN1YiI6Ijc3NjczZTUxLWIxY2UtNDg2OS05Yjg0LWQyZDQ0YmMxMzFhNCIsIm9yZyI6ImMwMTYyMTc4LTIyNzktNGEyMC04ZGJjLTg1Yzk0NTM2YzQ1NiIsImp0aSI6InB1YmxpYy1hcGkifQ.Kg8cCHSE4gN2tbvv3eukxXrVW4dLtQP55A_eYu0wRNk'.freeze

    class << self
      def get(resource:, id: nil, query: {})
        res = HTTParty.get(
          build_url(resource, id),
          headers: { 'Authorization' => BEARER_TOKEN },
          query: query
        )
        JSON.parse(res.body)['data']
      end

      private

      def build_url(resource, id = nil)
        arr = [BASE_URL, resource]
        arr << id if id.present?
        arr.join('/')
      end
    end
  end
end